<?php
function rfpge_logs()
{
    if( current_user_can('editor') || current_user_can('administrator') )
    {
        if(isset($_POST['rfpge_delete']) && $_POST['rfpge_delete'] == 'Delete Logs')
        {
            check_admin_referer( 'rfpge_save_rules', '_echor_nonce' );
            if(file_exists(WP_CONTENT_DIR . '/rfpge_info.log'))
            {
                unlink(WP_CONTENT_DIR . '/rfpge_info.log');
            }
        }
        if(isset($_POST['rfpge_delete_rules']) && $_POST['rfpge_delete_rules'] == 'Clear Running Rules List')
        {
            check_admin_referer( 'rfpge_save_rules', '_echor_nonce' );
            $running = array();
            update_option('rfpge_running_list', $running);
        }
        if(isset($_POST['rfpge_restore_defaults']) && $_POST['rfpge_restore_defaults'] == 'Restore Plugin Default Settings')
        {
            check_admin_referer( 'rfpge_save_rules', '_echor_nonce' );
            rfpge_activation_callback(true);
        }
        if(isset($_POST['rfpge_delete_all']) && $_POST['rfpge_delete_all'] == 'Delete All Generated Posts')
        {
            check_admin_referer( 'rfpge_save_rules', '_echor_nonce' );
            rfpge_delete_all_posts();
        }
        if(isset($_POST['rfpge_delete_all_rules']) && $_POST['rfpge_delete_all_rules'] == 'Delete All Generated Rules')
        {
            check_admin_referer( 'rfpge_save_rules', '_echor_nonce' );
            rfpge_delete_all_rules();
        }
    }
?>
<div class="wrap gs_popuptype_holder seo_pops">
    <div>
<script>
                var rfpge_admin_json = {
}
</script>
<div>
<h3>Rules Currently Running:<div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help" style="vertical-align: middle;">
                                        <div class="bws_hidden_help_text" style="min-width: 260px;">
                                            <?php
    echo "These rules are currently running on your server.";
?>
                        </div>
                    </div></h3>
                    <div>
<?php
    if (!get_option('rfpge_running_list')) {
        $running = array();
    } else {
        $running = get_option('rfpge_running_list');
    }
    if (!empty($running)) {
        echo '<ul>';
        foreach($running as $key => $thread)
        {
            echo '<li>ID - ' . htmlspecialchars($thread) . ' - started at: ' . gmdate("Y-m-d H:i:s", $key) . '</li>';
        }
        echo '</ul>'; 
        echo 'Current time: ' . gmdate("Y-m-d H:i:s", time());         
    }
    else
    {
        echo 'No rules are running right now<br/>';
    }
?>
                    </div>
                    <hr/>
    <form method="post" onsubmit="return confirm('Are you sure you want to clear the running list?');">
<?php
wp_nonce_field( 'rfpge_save_rules', '_echor_nonce' );
?>
<input name="rfpge_delete_rules" type="submit" title="Caution! This is for debugging purpose only!" value="Clear Running Rules List">
    </form>
    </div>
    <div class="hideMain">
    <br/><hr style=" height: 12px;border: 0;box-shadow: inset 0 12px 12px -12px rgba(0, 0, 0, 0.5);"/>    
        <div><h3>Backup Current Rules To File: <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help" style="vertical-align: middle;">
                                        <div class="bws_hidden_help_text" style="min-width: 260px;">
                                            <?php
    echo "Hit this button and you can backup the current rule settings to file. This is useful if you have many rules created and want to migrate settings to another server. <span style=\"color:red\">This feature is available only in the full version.</span>";
?>
                        </div>
                    </div></h3><hr/><form method="post" onsubmit="return confirm('Are you sure you want to download rule settings to file?');"><input name="rfpge_download_rules_to_file" type="submit" value="Download Rules To File" title="This feature is available only in the full version" disabled>
<?php
wp_nonce_field( 'rfpge_save_rules', '_echor_nonce' );
?></form></div>
    <br/><hr style=" height: 12px;border: 0;box-shadow: inset 0 12px 12px -12px rgba(0, 0, 0, 0.5);"/>    
        <div><h3>Load Rules From File: <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help" style="vertical-align: middle;">
                                        <div class="bws_hidden_help_text" style="min-width: 260px;">
                                            <?php
    echo "Here you can upload a previously downloaded backup file and restore the rules from it. <span style=\"color:red\">This feature is available only in the full version.</span>";
?>
                        </div>
                    </div></h3><hr/><form method="post" enctype="multipart/form-data" onsubmit="return confirm('Are you sure you want to load rules list from file?');"><label for="echo-file-upload-rules">Select File To Upload:&nbsp;&nbsp;</label><input type="file" id="echo-file-upload-rules" name="echo-file-upload-rules" title="This feature is available only in the full version" disabled value=""/><br/><br/>
                    <input name="rfpge_restore_rules" type="submit" value="Restore Rules From File" title="This feature is available only in the full version" disabled>
<?php
wp_nonce_field( 'rfpge_save_rules', '_echor_nonce' );
?></form></div>
    <br/><hr style=" height: 12px;border: 0;box-shadow: inset 0 12px 12px -12px rgba(0, 0, 0, 0.5);"/>    
        <div><h3>Restore Plugin Default Settings: <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help" style="vertical-align: middle;">
                                        <div class="bws_hidden_help_text" style="min-width: 260px;">
                                            <?php
    echo "Hit this button and the plugin settings will be restored to their default values. Warning! All settings will be lost!";
?>
                        </div>
                    </div></h3><hr/><form method="post" onsubmit="return confirm('Are you sure you want to restore the default plugin settings?');"><input name="rfpge_restore_defaults" type="submit" value="Restore Plugin Default Settings">
<?php
wp_nonce_field( 'rfpge_save_rules', '_echor_nonce' );
?></form></div>
                    <br/><hr style=" height: 12px;border: 0;box-shadow: inset 0 12px 12px -12px rgba(0, 0, 0, 0.5);"/>    
        <div><h3>Delete All Posts Generated by this Plugin: <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help" style="vertical-align: middle;">
                                        <div class="bws_hidden_help_text" style="min-width: 260px;">
                                            <?php
    echo "Hit this button and all posts generated by this plugin will be deleted!";
?>
                        </div>
                    </div></h3><hr/><form method="post" onsubmit="return confirm('Are you sure you want to delete all generated posts? This ca take a while, please be patient.');"><input name="rfpge_delete_all" type="submit" value="Delete All Generated Posts">
<?php
wp_nonce_field( 'rfpge_save_rules', '_echor_nonce' );
?></form></div>
                    <br/><hr style=" height: 12px;border: 0;box-shadow: inset 0 12px 12px -12px rgba(0, 0, 0, 0.5);"/>    
        <div><h3>Delete All Rules from 'Rss to Posts' Section: <div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help" style="vertical-align: middle;">
                                        <div class="bws_hidden_help_text" style="min-width: 260px;">
                                            <?php
    echo "Hit this button and all rules will be deleted!";
?>
                        </div>
                    </div></h3><hr/><form method="post" onsubmit="return confirm('Are you sure you want to delete all rules?');"><input name="rfpge_delete_all_rules" type="submit" value="Delete All Generated Rules">
<?php
wp_nonce_field( 'rfpge_save_rules', '_echor_nonce' );
?></form></div>
                    <br/><hr style=" height: 12px;border: 0;box-shadow: inset 0 12px 12px -12px rgba(0, 0, 0, 0.5);"/>    
                    <h3>Activity Log:<div class="bws_help_box bws_help_box_right dashicons dashicons-editor-help" style="vertical-align: middle;">
                                        <div class="bws_hidden_help_text" style="min-width: 260px;">
                                            <?php
    echo "This is the main log of your plugin. Here will be listed every single instance of the rules you run or are automatically run by schedule jobs (if you enable logging, in the plugin configuration).";
?>
                        </div>
                    </div></h3>
<div>
<?php
if(file_exists(WP_CONTENT_DIR . '/rfpge_info.log'))
{
    $log = file_get_contents(WP_CONTENT_DIR . '/rfpge_info.log');
    echo nl2br(htmlentities($log));
}
else
{
    echo "Log empty";
}
?>
</div>
        </div>
        <hr/> 
        <form method="post" onsubmit="return confirm('Are you sure you want to delete all logs?');">
   <input name="rfpge_delete" type="submit" value="Delete Logs">
<?php
wp_nonce_field( 'rfpge_save_rules', '_echor_nonce' );
?>
        </form>
</div>
</div>
<?php
}
?>